import System;
import ScriptPortal.Vegas;
import System.IO;
import System.Diagnostics;
import System.Windows.Forms;

// Start virtual file system, AviSynth and HandBrake
var cmd = "c:\\frameserver\\batch\\start_vegas2handbrake.bat";
var start : Process = Process.Start(cmd);

// Define DebugMode FrameServer as renderer
var videoRendererRegexp = /DebugMode FrameServer/;
var videoTemplateRegexp = /Audio: 48.0Khz, Video: project default/;

try 
{

// Check timeline's loop-region
    var renderStart = new Timecode();
    var renderLength = Vegas.Project.Length;
		{
            renderStart = Vegas.SelectionStart;
            renderLength = Vegas.SelectionLength;
		}

//Define export path and file name
    var projDir, projName, videoOutputFile;
    var projFile = Vegas.Project.FilePath;
    if ((null == projFile) || (0 == projFile.length)) 
	{
        projDir = "";
        projName = "Untitled";
	} 
    else 
	{
        projDir = Path.GetDirectoryName(projFile) + Path.DirectorySeparatorChar;
        projName = Path.GetFileNameWithoutExtension(projFile);
	}
    var outputDirectory = "C:\\frameserver\\source\\";
    videoOutputFile = outputDirectory + "vegas" + ".avi";
    if (null == videoOutputFile)
        throw "Process terminated";
    var aviRenderer = findRenderer(videoRendererRegexp);
    if (null == aviRenderer)
        throw "Could not find DebugMode FrameServer";

// Start export
    var videoTemplate = findTemplate(aviRenderer, videoTemplateRegexp);
    if (null == videoTemplate)
        throw "Could not find the render preset defined by the script";
    var renderStatus = Vegas.Render(videoOutputFile, videoTemplate, renderStart, renderLength);
    if (renderStatus != RenderStatus.Complete)
        throw "Render process not completed";

} catch (e) 

	{
    MessageBox.Show(e);
	}

// Find renderer
function findRenderer(re) 
	{
    var rendererEnum = new Enumerator(Vegas.Renderers);
    while (!rendererEnum.atEnd()) 
		{
        var renderer = rendererEnum.item();
        if (null != renderer.FileTypeName.match(re)) 
			{
            return renderer;
			}
        rendererEnum.moveNext();
    		}
    return null;
	}

//Find render preset
function findTemplate(renderer, re) 
	{
    var templateEnum = new Enumerator(renderer.Templates);
    while (!templateEnum.atEnd()) 
		{
        var template = templateEnum.item();
        if (null != template.Name.match(re)) 
			{
            return template;
        			}
        templateEnum.moveNext();
    		}
    return null;
	}